package org.netkernel.lang.javascript;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.layer0.util.XMLUtils;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.mozilla.javascript.xmlimpl.*;


public class XMLToDOM extends StandardTransreptorImpl
{
		public XMLToDOM()
		{	this.declareThreadSafe();
			this.declareFromRepresentation(XML.class);
			this.declareFromRepresentation(XMLList.class);
			this.declareToRepresentation(Document.class);
			this.declareToRepresentation(IReadableBinaryStreamRepresentation.class);
		}

		@Override
		public void onTransrept(INKFRequestContext context) throws Exception
		{	
			Object from=context.getThisRequest().getPrimary();
			Node n;
			if (from instanceof XML)
			{	n=((XML)from).toDomNode();
			}
			else
			{	n=((XMLList)from).toDomNode();
			}
			Document d=XMLUtils.newDocument();
			Node n2=d.importNode(n, true);
			d.appendChild(n2);
			INKFResponse resp;
			if (context.getThisRequest().getRepresentationClass()==Document.class)
			{	resp=context.createResponseFrom(d);
			}
			else
			{	Object transrepted=context.transrept(d, context.getThisRequest().getRepresentationClass());
				resp=context.createResponseFrom(d);
			}
			resp.setMimeType("text/xml");
		}
}
